--AH:ScriptId=31dd4cee-1f77-4b9f-984e-44abe38fa50a;550
CREATE TABLE [VariableDefinitions]
(
	[VariableDefinition_Id] INT IDENTITY NOT NULL,
	[Variable_Name] VARCHAR(50) NOT NULL,
	[Environment_Id] INT,
	[Server_Id] INT,
	[ApplicationGroup_Id] INT,
	[Application_Id] INT,
	[Deployable_Id] INT,
	[Release_Number] RELEASENUMBER,
	[Build_Number] BUILDNUMBER,
	[Value_Text] VARCHAR(MAX),

	CONSTRAINT [PK__VariableDefinitions]
		PRIMARY KEY ([VariableDefinition_Id]),
		
	CONSTRAINT [UQ__VariableDefinitions__Scope]
		UNIQUE ([Variable_Name], [Environment_Id], [Server_Id], [ApplicationGroup_Id], [Application_Id], [Deployable_Id], [Release_Number], [Build_Number]),
	
	CONSTRAINT [CK__VariableDefinitions__Scope]
	     CHECK --System 
			  ((	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL)

			   --Environment
			OR (	[Environment_Id] IS NOT NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL)

			  --Server
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NOT NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL)

			   --ApplicationGroup
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NOT NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL)

			   --Deployable
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NOT NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL)
				
			   --Application
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL)

			   --Release
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NOT NULL
				AND [Build_Number] IS NULL)

			   --Build
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NOT NULL
				AND [Build_Number] IS NOT NULL)

			   --Promotion
			OR (	[Environment_Id] IS NOT NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NOT NULL
				AND [Build_Number] IS NOT NULL))
)