--AH:ScriptId=abfca5bd-797b-48df-b91e-7a6148c4e369;2783
ALTER TABLE [VariableDeclarations]
  DROP CONSTRAINT [CK__VariableDeclarations__Scoped_Environment_Id__Scope_Code]
GO

ALTER TABLE [VariableDeclarations] 
  ADD CONSTRAINT [CK__VariableDeclarations__Scoped_Environment_Id__Scope_Code] CHECK (
    [Scope_Code] = 'X' 
    OR [Scope_Code] = 'P' AND [Scoped_Environment_Id] IS NOT NULL 
    OR ([Scope_Code] IN ('S', 'E', 'V', 'G', 'A', 'D', 'R', 'B') AND [Scoped_Environment_Id] IS NULL)
  )
GO

ALTER TABLE [VariableDefinitions]
  DROP COLUMN [Scope_Code]
GO

ALTER TABLE [VariableDefinitions]
	ADD [Scope_Code] AS 
	    CASE
            WHEN [Server_Id] IS NOT NULL THEN CAST('V' AS CHAR(1))
            WHEN [ApplicationGroup_Id] IS NOT NULL THEN CAST('G' AS CHAR(1))
            WHEN [Deployable_Id] IS NOT NULL THEN CAST('D' AS CHAR(1))
            WHEN [Environment_Id] IS NOT NULL AND [Build_Number] IS NULL THEN CAST('E' AS CHAR(1))
            WHEN [Application_Id] IS NOT NULL AND [Release_Number] IS NULL THEN CAST('A' AS CHAR(1))
            WHEN [Release_Number] IS NOT NULL AND [Build_Number] IS NULL THEN CAST('R' AS CHAR(1))
            WHEN [Execution_Id] IS NOT NULL THEN CAST('X' AS CHAR(1))
            WHEN [Build_Number] IS NOT NULL AND [Environment_Id] IS NULL THEN CAST('B' AS CHAR(1))
            WHEN [Environment_Id] IS NOT NULL AND [Execution_Id] IS NULL THEN CAST('P' AS CHAR(1))
            ELSE CAST('S' AS CHAR(1))
	    END 
       PERSISTED NOT NULL
GO

ALTER TABLE [VariableDefinitions]
  DROP CONSTRAINT [CK__VariableDefinitions__Scope]
GO

ALTER TABLE [VariableDefinitions] ADD CONSTRAINT [CK__VariableDefinitions__Scope] CHECK (
   [Environment_Id] IS NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NULL AND [Build_Number] IS NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NOT NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NULL AND [Build_Number] IS NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NULL AND [Server_Id] IS NOT NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NULL AND [Build_Number] IS NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NOT NULL AND [Application_Id] IS NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NULL AND [Build_Number] IS NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NULL AND [Deployable_Id] IS NOT NULL AND [Release_Number] IS NULL AND [Build_Number] IS NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NOT NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NULL AND [Build_Number] IS NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NOT NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NOT NULL AND [Build_Number] IS NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NOT NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NOT NULL AND [Build_Number] IS NOT NULL AND [Execution_Id] IS NULL 
OR [Environment_Id] IS NOT NULL AND [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NOT NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NOT NULL AND [Build_Number] IS NOT NULL AND [Execution_Id] IS NULL 
OR [Server_Id] IS NULL AND [ApplicationGroup_Id] IS NULL AND [Application_Id] IS NOT NULL AND [Deployable_Id] IS NULL AND [Release_Number] IS NOT NULL AND [Build_Number] IS NOT NULL AND [Execution_Id] IS NOT NULL)
GO