IF OBJECT_ID('TR__DeploymentPlanActionGroups__ValidateSequence') IS NOT NULL DROP TRIGGER [TR__DeploymentPlanActionGroups__ValidateSequence]
GO

CREATE TRIGGER [TR__DeploymentPlanActionGroups__ValidateSequence]
       ON [DeploymentPlanActionGroups] FOR UPDATE, INSERT, DELETE
AS 
BEGIN

	IF EXISTS(
			SELECT *
			  FROM [DeploymentPlanActionGroups] DPAG 
				   INNER JOIN (SELECT [DeploymentPlanActionGroup_Id], [DeploymentPlanActionGroup_Sequence],
									  [Actual_PlanActionGroup_Sequence] = 
										   ROW_NUMBER() OVER (PARTITION BY [DeploymentPlan_Id]
										   ORDER BY [DeploymentPlan_Id], [DeploymentPlanActionGroup_Sequence])
									  FROM [DeploymentPlanActionGroups]) DPAGS
						   ON DPAG.[DeploymentPlanActionGroup_Id] = DPAGS.[DeploymentPlanActionGroup_Id]
			 WHERE DPAG.[DeploymentPlanActionGroup_Sequence] <> DPAGS.[Actual_PlanActionGroup_Sequence]
			   AND ( 
			         EXISTS ( SELECT * FROM inserted
			                   WHERE DPAG.[DeploymentPlan_Id] = [DeploymentPlan_Id] )
					 OR 
			         EXISTS ( SELECT * FROM deleted
			                   WHERE DPAG.[DeploymentPlan_Id] = [DeploymentPlan_Id] )
				   )
		) 
	BEGIN

		RAISERROR('An invalid DeploymentPlanActionGroup_Sequence was provided for the DeploymentPlanActionGroup.', 16, 1)
		ROLLBACK

	END

END
GO