IF OBJECT_ID('[Applications_Extended]') IS NOT NULL DROP VIEW [Applications_Extended]
GO

CREATE VIEW [Applications_Extended]
AS
	SELECT A.[Application_Id],
		   A.[Application_Name],
		   A.[Application_Description],
		   A.[ReleaseNumber_Scheme_Name],
		   A.[BuildNumber_Scheme_Name],
		   A.[AllowMultipleActiveBuilds_Indicator],
		   A.[IssueTracking_Provider_Id],
		   A.[IssueTracking_CategoryIdList_Text],
		   A.[IssueTracking_Filter_Configuration],
           A.[IssueTracking_AllowBuildMasterIssues_Indicator],
		   A.[CreatedBy_User_Name],
		   A.[CreatedOn_Date],
		   A.[ModifiedBy_User_Name],
		   A.[ModifiedOn_Date],
		   A.[Dashboard_Text],
		   A.[ApplicationGroup_Id],
		   AG.[ApplicationGroup_Name],
		   AG.[ApplicationGroup_Description],
		   [Active_Releases_Count] = (SELECT COUNT(*) 
		                                FROM [Releases] 
		                               WHERE [Application_Id] = A.[Application_Id] 
		                                 AND [ReleaseStatus_Name] = 'Active'),
		   A.[VariableSupport_Code],
           [Issues_LastSynchronized_Date] = (SELECT MAX([IssueTracker_LastSync_Date]) 
                                               FROM [Issues] 
                                              WHERE [Application_Id] = A.[Application_Id]),
           [ShowDeployables_Indicator] = CASE 
                                            WHEN EXISTS(SELECT *
                                                       FROM [Deployables] D 
                                                      WHERE D.[Application_Id] = A.[Application_Id])
                                                 OR EXISTS(SELECT * 
                                                             FROM [DeployablesImported] DI 
                                                            WHERE DI.[Application_Id] = A.[Application_Id])
                                                 THEN 'Y' ELSE 'N'
                                         END,
           A.[Active_Indicator]

	  FROM [Applications] A
		   LEFT JOIN [ApplicationGroups] AG
				  ON A.[ApplicationGroup_Id] = AG.[ApplicationGroup_Id]