IF OBJECT_ID('[Applications_Health]') IS NOT NULL
	DROP VIEW [Applications_Health]
GO

CREATE VIEW [Applications_Health]
AS

	SELECT 
        A.[Application_Id],
        A.[Active_Indicator],
        [HasDeployable_Indicator] = CASE WHEN D.[HasDeployable_Indicator] IS NULL THEN 'N' ELSE 'Y' END,
        [HasRelease_Indicator] = CASE WHEN R.[HasRelease_Indicator] IS NULL THEN 'N' ELSE 'Y' END,
        [HasActiveWorkflow_Indicator] = CASE WHEN AW.[HasActiveWorkflow_Indicator] IS NULL THEN 'N' ELSE 'Y' END,
        [HasDeploymentPlan_Indicator] = CASE WHEN ADP.[HasDeploymentPlan_Indicator] IS NULL THEN 'N' ELSE 'Y' END,
        [ShowHealthPage_Indicator] = CASE WHEN
                                        D.[HasDeployable_Indicator] IS NULL OR 
                                        R.[HasRelease_Indicator] IS NULL OR
                                        AW.[HasActiveWorkflow_Indicator] IS NULL OR
                                        ADP.[HasDeploymentPlan_Indicator] IS NULL
                                     THEN 'Y' ELSE 'N' END

	  FROM [Applications] A

      OUTER APPLY(
        SELECT TOP 1 [HasDeployable_Indicator] = 'Y' FROM [Deployables] D WHERE D.[Application_Id] = A.[Application_Id]
      ) D

      OUTER APPLY(
        SELECT TOP 1 [HasRelease_Indicator] = 'Y' FROM [Releases] R WHERE R.[Application_Id] = A.[Application_Id]
      ) R

      OUTER APPLY(
        SELECT TOP 1 [HasActiveWorkflow_Indicator] = 'Y' FROM [ApplicationWorkflows] AW WHERE AW.[Application_Id] = A.[Application_Id]
      ) AW

      OUTER APPLY(
        SELECT TOP 1 [HasDeploymentPlan_Indicator] = 'Y' FROM [ApplicationDeploymentPlans] ADP WHERE ADP.[Application_Id] = A.[Application_Id]
      ) ADP
 