IF OBJECT_ID('[BuildTestResults_TestGroupResults]') IS NOT NULL DROP VIEW [BuildTestResults_TestGroupResults]
GO

CREATE VIEW [BuildTestResults_TestGroupResults] AS

SELECT TR.[Execution_Id],
       TR.[Group_Name],
	   BP.[Build_Id],
       COUNT(*) AS [Total_Tests], 
       COUNT(NULLIF(NULLIF(TR.[TestStatus_Code], 'F'), 'I')) AS [Passed_Tests],
       COUNT(NULLIF(NULLIF(TR.[TestStatus_Code], 'P'), 'I')) AS [Failed_Tests],
       COUNT(NULLIF(NULLIF(TR.[TestStatus_Code], 'P'), 'F')) AS [Inconclusive_Tests]
  FROM [BuildTestResults] TR
       INNER JOIN [BuildExecutions] BE
               ON BE.[Execution_Id] = TR.[Execution_Id]
	   INNER JOIN [BuildPromotions] BP
	           ON BP.[Promotion_Id] = BE.[Promotion_Id]
 GROUP BY 
    TR.[Execution_Id], 
    TR.[Group_Name],
	BP.[Build_Id]
