EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ExtensionConfiguration_GetConfiguration',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'ExtensionConfigurations',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the details of an extension configurer for extension with the specified name'
GO

IF OBJECT_ID('[ExtensionConfiguration_GetConfiguration]') IS NOT NULL DROP PROCEDURE [ExtensionConfiguration_GetConfiguration]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ExtensionConfiguration_GetConfiguration] 
(
	@QualifiedType_Name VARCHAR(500),
	@Profile_Name VARCHAR(50)
)
AS
BEGIN

SET NOCOUNT ON

	SELECT * FROM [ExtensionConfigurations]
	 WHERE [QualifiedType_Name] = @QualifiedType_Name
	   AND ([Profile_Name] = @Profile_Name OR [Default_Indicator] = 'Y')


END
GO

GRANT EXECUTE ON [ExtensionConfiguration_GetConfiguration] TO [BuildMasterUser_Role]
GO