EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'LegacyExecutions_CompleteAction',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ NULL,
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Marks an action as completed.'
GO


IF OBJECT_ID('[LegacyExecutions_CompleteAction]') IS NOT NULL DROP PROCEDURE [LegacyExecutions_CompleteAction]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [LegacyExecutions_CompleteAction]
(
	@BuildExecution_ActionGroupAction_Id INT,
	@ExecutionStatus_Name VARCHAR(10)
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	UPDATE [BuildExecution_ActionGroupActions]
	   SET [ExecutionEnded_Date] = GETUTCDATE(),
	       [ExecutionStatus_Name] = @ExecutionStatus_Name,
	       [WarningLogEntry_Indicator] = CASE WHEN @ExecutionStatus_Name = 'Succeeded'
	                                           AND EXISTS(SELECT *
	                                                        FROM [BuildExecution_ActionGroupActionLogEntries] BEAGALE
	                                                       WHERE BEAGALE.[BuildExecution_ActionGroupAction_Id] = @BuildExecution_ActionGroupAction_Id
	                                                         AND BEAGALE.[LogEntry_Level] >= 20
	                                                         AND BEAGALE.[LogEntry_Level] < 30)
	                                          THEN 'Y'
	                                          ELSE 'N'
	                                     END
	 WHERE [BuildExecution_ActionGroupAction_Id] = @BuildExecution_ActionGroupAction_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [LegacyExecutions_CompleteAction] TO [BuildMasterUser_Role]
