EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'LogMessages_GetMessages',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'LogMessages_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the messages from the error log that match the specified criteria'
GO

IF OBJECT_ID('[LogMessages_GetMessages]') IS NOT NULL DROP PROCEDURE [LogMessages_GetMessages]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [LogMessages_GetMessages]
(
	@Row_Count INT,
	@Message_Level INT = NULL,
    @Category_Name VARCHAR(30) = NULL,
    @Application_Id INT = NULL,
    @Schedule_Id INT = NULL,
    @Requirement_Id INT = NULL,
    @Provider_Id INT = NULL,
    @EventListener_Id INT = NULL,
    @Server_Id INT = NULL
) AS
BEGIN

    SET NOCOUNT ON

	IF @Row_Count IS NOT NULL
	    SET ROWCOUNT @Row_Count

    SELECT * FROM [LogMessages_Extended]
     WHERE (@Message_Level IS NULL OR [Message_Level] >= @Message_Level)
       AND (@Category_Name IS NULL OR [Category_Name] = @Category_Name)
       AND (@Application_Id IS NULL OR [Application_Id] = @Application_Id)
       AND (@Schedule_Id IS NULL OR [Schedule_Id] = @Schedule_Id)
       AND (@Requirement_Id IS NULL OR [Requirement_Id] = @Requirement_Id)
       AND (@Provider_Id IS NULL OR [Provider_Id] = @Provider_Id)
       AND (@EventListener_Id IS NULL OR [EventListener_Id] = @EventListener_Id)
       AND (@Server_Id IS NULL OR [Server_Id] = @Server_Id)
     ORDER BY [Logged_Date] DESC

END
GO

GRANT EXECUTE ON [LogMessages_GetMessages] TO [BuildMasterUser_Role]