EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Pipelines_DeletePipeline',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a pipeline.'
GO


IF OBJECT_ID('[Pipelines_DeletePipeline]') IS NOT NULL DROP PROCEDURE [Pipelines_DeletePipeline]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Pipelines_DeletePipeline]
(
	@Pipeline_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

 	DELETE [Pipelines] WHERE [Pipeline_Id] = @Pipeline_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Pipelines_DeletePipeline] TO [BuildMasterUser_Role]
