EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Pipelines_GetPipelines',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Pipelines',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Returns the pipelines in the system, optionally filtered by application.'
GO


IF OBJECT_ID('[Pipelines_GetPipelines]') IS NOT NULL DROP PROCEDURE [Pipelines_GetPipelines]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Pipelines_GetPipelines]
(
	@Application_Id INT = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT *
	  FROM [Pipelines]
     WHERE @Application_Id IS NULL OR [Application_Id] = @Application_Id

END
GO

GRANT EXECUTE ON [Pipelines_GetPipelines] TO [BuildMasterUser_Role]