EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Pipelines_UpdatePipeline',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Updates a pipeline.'
GO

IF OBJECT_ID('[Pipelines_UpdatePipeline]') IS NOT NULL DROP PROCEDURE [Pipelines_UpdatePipeline]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Pipelines_UpdatePipeline]
(
	@Pipeline_Id INT,
    @Pipeline_Name VARCHAR(255) = NULL,
    @Pipeline_Configuration XML = NULL,
    @Active_Indicator YNINDICATOR = NULL,
	@Pipeline_Color VARCHAR(20) = NULL
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION


	UPDATE [Pipelines]
       SET [Pipeline_Name] = COALESCE(@Pipeline_Name, [Pipeline_Name]),
           [Pipeline_Configuration] = COALESCE(@Pipeline_Configuration, [Pipeline_Configuration]),
           [Active_Indicator] = COALESCE(@Active_Indicator, [Active_Indicator]),
           [ModifiedOn_Date] = GETUTCDATE(),
           [ModifiedBy_User_Name] = dbo.Session_GetUserName(),
		   [Pipeline_Color] = COALESCE(@Pipeline_Color, [Pipeline_Color])
     WHERE [Pipeline_Id] = @Pipeline_Id

	--EXEC [Events_RaiseEvent] 'PLNMOD', NULL, @Pipeline_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Pipelines_UpdatePipeline] TO [BuildMasterUser_Role]
