EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_GetAllPlans',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Plans_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Returns all OtterScript plans at the specified scope.'
GO

IF OBJECT_ID('[Plans_GetAllPlans]') IS NOT NULL DROP PROCEDURE [Plans_GetAllPlans]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_GetAllPlans]
(
    @Application_Id INT = NULL,
    @PlanType_Code CHAR(1) = NULL,
    @IncludeGlobal_Indicator YNINDICATOR = 'Y'
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT *
	  FROM [Plans_Extended]
     WHERE (@Application_Id IS NULL OR [Application_Id] = @Application_Id)
       AND (@PlanType_Code IS NULL OR [PlanType_Code] = @PlanType_Code)
       AND (
            (@IncludeGlobal_Indicator = 'N' AND [Application_Id] IS NOT NULL)
         OR (@IncludeGlobal_Indicator = 'Y' AND [Application_Id] IS NULL)
       )
     ORDER BY [Plan_Name]

END
GO

GRANT EXECUTE ON [Plans_GetAllPlans] TO [BuildMasterUser_Role]