EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_GetGlobalDeploymentPlans',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'DeploymentPlans',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Returns named deployment plans and optionally plans orphaned.'
GO


IF OBJECT_ID('[Plans_GetGlobalDeploymentPlans]') IS NOT NULL DROP PROCEDURE [Plans_GetGlobalDeploymentPlans]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_GetGlobalDeploymentPlans]  AS
BEGIN
	SET NOCOUNT ON
	
	SELECT * INTO #DeploymentPlans
	  FROM [DeploymentPlans]
	 WHERE [DeploymentPlan_Name] IS NOT NULL
	    OR (    [DeploymentPlan_Id] NOT IN (SELECT [DeploymentPlan_Id] FROM [WorkflowSteps] WHERE [DeploymentPlan_Id] IS NOT NULL)
	        AND [DeploymentPlan_Id] NOT IN (SELECT [Build_DeploymentPlan_Id] FROM [Workflows] WHERE [Build_DeploymentPlan_Id] IS NOT NULL))

	SELECT * FROM #DeploymentPlans
         ORDER BY [DeploymentPlan_Name]
									 
END
GO

GRANT EXECUTE ON [Plans_GetGlobalDeploymentPlans] TO [BuildMasterUser_Role]
