EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_SetOtterScript',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Sets the Otter script of a plan.'
GO


IF OBJECT_ID('[Plans_SetOtterScript]') IS NOT NULL DROP PROCEDURE [Plans_SetOtterScript]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_SetOtterScript]
(
	@DeploymentPlan_Id INT,
	@OtterScript_Bytes VARBINARY(MAX)
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	UPDATE [DeploymentPlans]
	   SET [OtterScript_Bytes] = @OtterScript_Bytes
	 WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id

	EXEC [Events_RaiseEvent] 'PLNMOD', NULL, @DeploymentPlan_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Plans_SetOtterScript] TO [BuildMasterUser_Role]
