EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Releases_DeleteReleaseDeployable',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Removes a deployable from the release.'
GO


IF OBJECT_ID('[Releases_DeleteReleaseDeployable]') IS NOT NULL DROP PROCEDURE [Releases_DeleteReleaseDeployable]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Releases_DeleteReleaseDeployable]
(
	@Application_Id INT,
	@Release_Number RELEASENUMBER,
	@Deployable_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DECLARE @Release_Id INT
	SELECT @Release_Id = [Release_Id]
	  FROM [Releases]
	 WHERE [Application_Id] = @Application_Id
	   AND [Release_Number] = @Release_Number

	DELETE [ReleaseDeployables]
	 WHERE [Release_Id] = @Release_Id
	   AND [Deployable_Id] = @Deployable_Id

	COMMIT

END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Releases_DeleteReleaseDeployable] TO [BuildMasterUser_Role]
