EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Scripts_DeleteParameter',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a script parameter.'
GO


IF OBJECT_ID('[Scripts_DeleteParameter]') IS NOT NULL DROP PROCEDURE [Scripts_DeleteParameter]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Scripts_DeleteParameter]
(
	@Script_Id INT,
	@Parameter_Name NVARCHAR(50)
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DELETE [ScriptParameters]
	 WHERE [Script_Id] = @Script_Id
	   AND [Parameter_Name] = @Parameter_Name

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH


END
GO

GRANT EXECUTE ON [Scripts_DeleteParameter] TO [BuildMasterUser_Role]