EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Servers_GetServer',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'Servers,Environments_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the details of a specific server and its environments.'
GO


IF OBJECT_ID('[Servers_GetServer]') IS NOT NULL DROP PROCEDURE [Servers_GetServer]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Servers_GetServer]
(
	@Server_Id INT
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT * 
	  FROM [Servers]
	 WHERE [Server_Id] = @Server_Id

	SELECT *
	  FROM [Environments_Extended]
	 WHERE [Environment_Id] IN (SELECT [Environment_Id] FROM [EnvironmentServers]
	                             WHERE [Server_Id] = @Server_Id)

END
GO

GRANT EXECUTE ON [Servers_GetServer] TO [BuildMasterUser_Role]