EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'TextTemplates_GetTemplateByName',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'TextTemplates',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the text template which has the specified name and type that is visible to the specified application.'
GO

IF OBJECT_ID('[TextTemplates_GetTemplateByName]') IS NOT NULL DROP PROCEDURE [TextTemplates_GetTemplateByName]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [TextTemplates_GetTemplateByName]
(
	@Application_Id INT,
	@Template_Name VARCHAR(200)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT *
	  FROM [TextTemplates]
     WHERE ([Application_Id] = @Application_Id OR [Application_Id] IS NULL)
	   AND [Template_Name] = @Template_Name
     ORDER BY COALESCE([Application_Id], 0) DESC 

END
GO

GRANT EXECUTE ON [TextTemplates_GetTemplateByName] TO [BuildMasterUser_Role]