EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Users_SetPassword',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ NULL,
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Stored procedure for internal use only.'
GO

IF OBJECT_ID('[Users_SetPassword]') IS NOT NULL
	DROP PROCEDURE [Users_SetPassword]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Users_SetPassword]
(
	@User_Name USERNAME,
	@Password_Bytes BINARY(20),
	@Salt_Bytes BINARY(10),
	@ClearChangePasswordOnLogin_Indicator YNINDICATOR = NULL
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION
	
	UPDATE [Users]
	   SET [Password_Bytes] = @Password_Bytes,
	       [Salt_Bytes] = @Salt_Bytes,
           [LegacyPassword_Indicator] = 'N',
		   [ChangePasswordOnLogin_Indicator] = CASE WHEN @ClearChangePasswordOnLogin_Indicator = 'Y' THEN 'N' ELSE [ChangePasswordOnLogin_Indicator] END
	 WHERE [User_Name] = @User_Name

	EXEC [Events_RaiseEvent] 'USRMDU', NULL, @User_Name

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Users_SetPassword] TO [BuildMasterUser_Role]
GO
