﻿param([switch]$all)

$connString = 'Data Source=(localdb)\MSSQLLocalDB; Initial Catalog=BuildMaster; Integrated Security=true;'
$conn = New-Object -TypeName System.Data.SqlClient.SqlConnection -ArgumentList ($connString)
try {
    $conn.Open()

    $path = 'OBJECTS'
    if($all) {
        $path = '.'
    }

    $scripts = (Get-ChildItem -Path $path -Filter *.sql -Recurse)
    $index = 0

    foreach($sqlFile in $scripts) {

        Write-Progress -Activity "Running SQL scripts..." -Status $sqlFile.FullName -PercentComplete ($index / $scripts.Length * 100)
        $index++

        $fullScriptText = [System.IO.File]::ReadAllText($sqlFile.FullName)
        $scriptParts = $fullScriptText -isplit '^\s*GO\s*$', 0, "multiline"

        foreach($scriptText in $scriptParts) {
            if([System.String]::IsNullOrWhiteSpace($scriptText)) {
                continue;
            }

            $cmd = New-Object System.Data.SqlClient.SqlCommand -ArgumentList ($scriptText, $conn)
            try {
                try {
                    $cmd.ExecuteNonQuery() | Out-Null
                } catch [System.Data.SqlClient.SqlException] {
                    Write-Error "Error in $($sqlFile.Name): $($error[0].Exception.Message)"
                    break;
                }
            }
            finally {
                $cmd.Dispose()
            }
        }
    }
} finally {
    $conn.Dispose()
}